#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <security/pam_userpass.h>

int do_pam_chpass(const char *service, const char *user, const char *pass)
{
	pam_handle_t *pamh;
	pam_userpass_t userpass;
	struct pam_conv conv = {pam_userpass_conv, &userpass};
	int status;

	userpass.user = user;
	userpass.pass = pass;

	status = pam_start(service, user, &conv, &pamh);
	if (status != PAM_SUCCESS) {
		fprintf(stderr, "pam_start: Failed with code %d\n", status);
		return 0;
	}

	status = pam_chauthtok(pamh, 0);
	if (status != PAM_SUCCESS) {
		fprintf(stderr, "pam_chauthtok: %s\n",
			pam_strerror(pamh, status));
		pam_end(pamh, status);
		return 0;
	}

	status = pam_end(pamh, status);
	if (status != PAM_SUCCESS) {
		fprintf(stderr, "pam_end: Failed with code %d\n", status);
		return 0;
	}

	return 1;
}
